/**
 * @author spothineni
 * 
 * This is model for reprocessing sub-tab of Analysis tab
 */
package gov.anl.gmca.dataproc;

import gov.anl.gmca.dataproc.ModelDataProc.DataProcField;
import gov.anl.gmca.util.ListenerList;

public class ModelReprocessing {
	public ListenerList<ModelReprocessing> ll;

	public static String UNIT_CELL = "";
	public static int SPACE_GROUP = 1;
	public static int firstImg = 1;
	public static int lastImg = 2;
	public static double RESOLUTION_LOW = 50.0;
	public static double RESOLUTION_HIGH = 0.0;
	public static boolean takeSettings = true;
	public static String[] UnitCell = { "a", "b", "c", "\u03B1", "\u03B2",
			"\u03B3" };
	protected static ModelReprocessing inst = null;

	public static ModelReprocessing get() {
		return inst;
	}

	public ModelReprocessing() {
		inst = this;
		ll = new ListenerList<ModelReprocessing>(this);
	}
	public static String getProcDir(String pipeline) {
		/* decide on work directory */
		String processingDir = ModelDataProcList.get().getCurrentResult()
				.getField(DataProcField.IMAGEDIR)+"/"+ModelDataProcList.get().getCurrentResult()
				.getField(DataProcField.SAMPLE_NAME);
		int sampNumber = DevDataProc.getRowCount() + 1;
		return processingDir += "_" + pipeline + "_Reprocess" + sampNumber;
		
	}
}
