package gov.anl.gmca.gui;

public class GUIUtil
{
	// if no BluIce method is found, it just returns the top of the stack
	public static String getTopBluIceMethodFromStack(Thread thread)
	{
		for (StackTraceElement element : thread.getStackTrace())
		{
			if (element.getClassName().contains("gov.anl.gmca") &&
				!element.getMethodName().contains("getTopBluIceMethodFromStack") &&
				!element.getMethodName().contains("logCall") &&
				!element.getMethodName().contains("asyncExec"))
			{
				return element.toString();
			}
		}
		return thread.getStackTrace()[0].toString();
	}
}
