package gov.anl.gmca.scan;

import gov.anl.gmca.util.ActionResult;

public class CmdOptDetector extends CmdScan
{
	protected boolean doMove;
	protected ActionResult result = null;
	
	public CmdOptDetector(boolean doMove)
	{
		this.doMove = doMove;
	}
	
	@Override
	public void run()
	{
		result = DevOptimizeFluo.run(doMove);
	}
	
	public ActionResult getResult()
	{
		return result;
	}
	
	@Override
	public void requestStop()
	{
		DevOptimizeFluo.stop();
	}
}
