/**
 * @author spothineni
 * This class is collection of static variables used for screening Tasks
 * 
 */

package gov.anl.gmca.screening;

import gov.anl.gmca.util.ListenerList;

public class ModelScreeningTasks {
	public ListenerList<ModelScreeningTasks> ll;;
	protected static ModelScreeningTasks inst = null;

	public static int DIFFIMAGES0 = 1;
	public static int DIFFIMAGES45 = 1;
	public static int DIFFIMAGES90 = 1;

	public static double detectorDistance = 300.0;
	public static double delta = 1.0;
	public static double exposureTime = 1.0;
	public static String beamsize = "20x20";
	public static double attenuation = 5.0;
	public static double energy = 12.0;
	public static double beamstop = 36.0;

	public static ModelScreeningTasks get() {
		return inst;
	}

	public ModelScreeningTasks() {
		inst = this;
		ll = new ListenerList<ModelScreeningTasks>(this);
	}
}
