package gov.anl.gmca.screening;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.Viewer;

import java.util.Hashtable;

public class ScreenContentProvider implements IStructuredContentProvider {
	private TableViewer tableViewer;
	private Hashtable<Integer, ModelRowData> data;

	public ScreenContentProvider(TableViewer tv) {
		this.tableViewer = tv;
	}

	@Override
	public void dispose() {
	}

	@Override
	public void inputChanged(Viewer arg0, Object arg1, Object arg2) {
	}

	@Override
	public Object[] getElements(Object obj) {
		data = ((ModelSilTable) obj).data;
		Object[] elements = new Object[data.size()];
		for (int i = 0; i < data.size(); i++) {
			elements[i] = data.get(i);
		}
		return elements;
	}
}
