package gov.anl.gmca.util;

public class Pair<T1,T2>
{
	public T1 a;
	public T2 b;
	
	public Pair(T1 a, T2 b)
	{
		this.a=a;
		this.b=b;
	}
	
	@Override
	public boolean equals(Object other)
	{
		if (!(other instanceof Pair<?,?>)) return false;
		
		Pair<?,?> otherP = (Pair<?,?>)other;
		
		if (!otherP.a.equals(a) || !otherP.b.equals(b)) return false;
		
		return true;
	}
	
	@Override
	public int hashCode()
	{
		return a.hashCode()+b.hashCode();
	}
}
