package gov.anl.gmca.util;

public class PerfTimer
{
	protected long startTime;
	protected String prefix = "Elapsed: ";
	
	public PerfTimer()
	{
		saveStartTime();
	}
	
	public PerfTimer(String prefix)
	{
		this.prefix=prefix;
		saveStartTime();
	}

	protected void saveStartTime()
	{
		startTime = System.currentTimeMillis();
	}
	
	public long getElapsedMs()
	{
		long currentTime = System.currentTimeMillis();
		return (currentTime - startTime);
	}
	
	public void printElapsedMs()
	{
		System.out.println(prefix+getElapsedMs()+"ms");
	}

	public void printElapsedMs(String s) {
		System.out.println(s+getElapsedMs()+"ms");
	}
}
