package gov.anl.aps.gmca;

import java.awt.*;
import java.sql.*;
import java.util.*;
import javax.swing.*;

public class DB
{
	protected static HashMap configMap = new HashMap();
	protected static boolean firstLoad = false;
	
    protected static Connection conn = null;
    protected static Statement st = null;
    protected static ResultSet rs = null;
    protected static String pwd = null;
    
    protected static ResultSet execQuery(String query)
	{
    	while (pwd == null)
    	{
    		/*JFrame frame = new JFrame("Password required");
    		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    		frame.setBackground(GUI.bgColor);

    		JPanel jplMain = new JPanel(new GridBagLayout());
    		jplMain.setBackground(GUI.bgColor);
    		frame.getContentPane().add(jplMain);
    		
    		GridBagConstraints gbc = new GridBagConstraints();
    		gbc.insets = new Insets(10,5,5,5);
    		
    		JLabel lblPwd = new JLabel("gmca password:");
    		gbc.gridx = 0;
    		gbc.gridy = 0;
    		gbc.gridwidth = 2;
    		jplMain.add(lblPwd, gbc);
    		
    		JPasswordField pwdField = new JPasswordField(8);
    		gbc.gridx = 0;
    		gbc.gridy = 1;
    		gbc.gridwidth = 2;
    		jplMain.add(pwdField, gbc);
    		
    		JButton okButton = new JButton("OK");
    		okButton.setBackground(GUI.btnColor);
    		gbc.gridx = 0;
    		gbc.gridy = 2;
    		gbc.gridwidth = 1;
    		jplMain.add(okButton, gbc);
    		
    		JButton cancelButton = new JButton("Cancel");
    		cancelButton.setBackground(GUI.btnColor);
    		gbc.gridx = 1;
    		gbc.gridy = 2;
    		gbc.gridwidth = 1;
    		jplMain.add(cancelButton, gbc);
    		
    		frame.pack();
    		frame.setVisible(true);*/
    		
    		JPasswordField pwdField = new JPasswordField(12);
    		int action = JOptionPane.showConfirmDialog(null, pwdField, "Enter gmca password",JOptionPane.OK_CANCEL_OPTION);
    	    if (action == 0)
    	    {
    	    	pwd = new String(pwdField.getPassword());
    	    }
    	    else
    	    {
    	    	System.out.println("Password entry canceled.");
    	    	System.exit(-1);
    	    }
    	}
    	
	    try
	    {
	    	Class.forName("com.mysql.jdbc.Driver").newInstance();
	    	conn = DriverManager.getConnection("jdbc:mysql://"+Main.getHostname()+"/blc2004","gmca",pwd);

			if(conn.isClosed())
			{
				throw new Exception("Error opening database connection.");
			}
			System.out.println("Connected to "+Main.getHostname()+", executing query: "+query);
			
			st = conn.createStatement();
			
			if (st.execute(query))
			{
				rs = st.getResultSet();
			}
	    }
		catch (SQLException sqle)
		{
			sqle.printStackTrace();
		}
		catch (IllegalAccessException iae)
		{
			iae.printStackTrace();
		}
		catch (ClassNotFoundException cnfe)
		{
			cnfe.printStackTrace();
		}
		catch (InstantiationException ie)
		{
			ie.printStackTrace();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	    return rs;
	}
    
    protected static void closeQuery()
    {
    	if (conn != null)
    	{
    		try { conn.close(); conn = null; } catch (SQLException sqle) { sqle.printStackTrace(); }
    	}
    	if (st != null)
    	{
    		try { st.close(); conn = null; } catch (SQLException sqle) { sqle.printStackTrace(); }
    	}
    }
    
	public static void update()
	{
		try
		{
			ResultSet rs = execQuery("select * from Config");

			while (rs.next())
			{
				String id = rs.getString("ID");
				String value = rs.getString("Value");
				
				System.out.println("\t"+id+" = "+value);
				configMap.put(id,value);
			}
			firstLoad = true;
		}
		catch (SQLException sqle)
		{
			sqle.printStackTrace();
		}
		finally
		{
			closeQuery();
		}
	}
	
	public static String get(String id)
	{
		if (!firstLoad) update();
		String ret = (String)configMap.get(id);
		return ret;
	}
	
	public static double getDouble(String id)
	{
		double ret = Double.parseDouble(get(id));
		return ret;
	}
	
	public static boolean getBoolean(String id)
	{
		String val = get(id);
		
		if (!val.equals("true") && !val.equals("false"))
		{
			System.out.println("WARNING: "+val+" should be 'true' or 'false'");
		}
		
		return val.equals("true");
	}
	
	public static boolean set(String id, String value)
	{
		execQuery("update Config set Value = '"+value+"' where ID = '"+id+"'");
		return true;
	}

	public static boolean setDouble(String id, double value)
	{
		Double d = new Double(value);
		return set(id, d.toString());
	}

	public static boolean setBoolean(String id, boolean value)
	{
		return set(id, value?"true":"false");
	}
}
