#!/usr/bin/python2 -W all

import sys
import os, time

if len(sys.argv)==2 and sys.argv[1]=="check":
    print "check OK"
    sys.exit(0)

if (len(sys.argv)<4):
    scriptName = sys.argv[0][sys.argv[0].rfind('/')+1:]
    print ""
    print "Usage: "+scriptName+" file_count directory_path file1 [file2...]"
    print ""
    sys.exit(-1)

if (sys.argv[1].isdigit()==False):
    print "File count is not a positive integer"
    sys.exit(-1)
    

fileCount=int(sys.argv[1])
if (fileCount*2 != len(sys.argv)-3):
    print "File count does not match arguments"
    sys.exit(-1)

dir=sys.argv[2]
fileList=sys.argv[3:]
euid=os.geteuid()

print "=== safe_image_delete ==="
print ""
print "got dir "+dir+" and "+str(fileCount)+" files"
print ""

for i in range(0,len(fileList),2):
    filename=fileList[i]
    modTime=int(fileList[i+1])
    ramdiskPath = "/ppu"+dir+"/"+filename
    (mode, ino, dev, nlink, uid, gid, size, atime, mtime, ctime) = os.stat(ramdiskPath)
    matchString = "match" if modTime==mtime else "MISMATCH"
    idMatchString = "match" if euid==uid else "MISMATCH"
    okToDelete = modTime==mtime and euid==uid
    print "got file "+filename+" with modTimes "+str(modTime)+"-"+str(mtime)+" "+matchString+" uid="+str(euid)+"-"+str(uid)+" "+idMatchString+" okToDelete="+str(okToDelete)
    if okToDelete:
        os.remove(ramdiskPath)

print "Done."
