package gov.anl.gmca.common.ui;

import org.eclipse.swt.widgets.Composite;

public abstract class Tab extends Composite
{
	public interface VisibilityListener
	{
		public abstract void notifyIsVisible(boolean isVisible);
	}
	
	protected Composite _parent;
	
	public Tab(Composite parent, int style)
	{
		super(parent,style);
		_parent = parent;
	}
	
	public void notifyIsVisible(boolean isVisible) {}
	public void connectListeners() {}
	public abstract String getTabName();
}
