/**
 * @author spothineni
 * This class runs logview command 
 * logview command displays CCP4 style logs such as aimless log, truncate log
 * in qtrview
 */

package gov.anl.gmca.dataproc;

import gov.anl.gmca.io.ExecTask;
import gov.anl.gmca.syslog.Log;

import java.io.File;

public class CmdLogview implements Runnable {
	private Thread th;
	private String log = "";
	private String thName;

	public CmdLogview(String _log, String name) {
		log =_log;
		thName = name;
	}

	@Override
	public void run() {
		
		File file = new File(log);
		if (file.exists()) {
			ExecTask task = ExecTask.new_ExecTask("logview " + log + "",
					"logview", false, false);
			task.start();
			task.waitFor();
			
		} else {
			Log.error(log + " doesn't exists");
		}
	}
	public void start() {
		if(th == null) {
			th = new Thread (this, thName);
			th.start();
		}
	}
}
