package gov.anl.gmca.diffimage;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.awt.image.BufferedImageOp;
import java.awt.image.RescaleOp;

public class DiffractionImage16Bit extends DiffractionImage
{
	public BufferedImage originalImg;
	@Override public boolean hasValidImage() { return null != originalImg; }
	@Override public int origWidth() { return originalImg.getWidth(); }
	@Override public int origHeight() { return originalImg.getHeight(); }
	
	@Override public void setContrast(double gray)
	{
		if (this.gray==gray) return;
		this.gray=gray;
		
		createContrastImage();
		
		Graphics2D g2d = (Graphics2D)contrastImg.getGraphics();
		BufferedImageOp contrastOp = new RescaleOp(-10000f, 65535f, null);
		g2d.drawImage(originalImg, contrastOp, 0, 0);
		g2d.dispose();
	}
}
