package gov.anl.gmca.server.workers;

import gov.anl.gmca.common.client_server.RPC.RPCResult;
import gov.anl.gmca.hutch.CmdEnterHutch;
import gov.anl.gmca.server.Worker;

public class EnterHutch extends Worker
{
    public EnterHutch()
    {
        super("EnterHutch");
    }

    @Override
    public void run()
    {
        CmdEnterHutch enterHutchCmd = new CmdEnterHutch();
        enterHutchCmd.start();
        enterHutchCmd.waitFor();
        result = RPCResult.OK;
    }

    @Override
    public String jsonStatus()
    {
        return "id="+id+" result="+result;
    }
}
