package gov.anl.gmca.server.workers;

import gov.anl.gmca.common.client_server.RPC.RPCResult;
import gov.anl.gmca.hutch.DevAlignMinibeam;
import gov.anl.gmca.server.Worker;

public class OptimizeBeam extends Worker
{
    public OptimizeBeam()
    {
        super("OptimizeBeam");
    }

    @Override
    public void run()
    {
        try {
            DevAlignMinibeam.get().syncExec();
            result = RPCResult.OK;
        } catch (Exception e) {
            e.printStackTrace();
            result = RPCResult.ERROR;
        }
    }

    @Override
    public String jsonStatus()
    {
        return "id="+id+" result="+result;
    }
}
