package gov.anl.gmca.util;

import java.awt.*;
import java.awt.image.ImageObserver;

public class ImageWaiter implements ImageObserver
{
	protected boolean isDone = false;
	public boolean getDone() { return isDone; }
	
	@Override
	public boolean imageUpdate(Image img, int infoflags, int x, int y, int width, int height)
	{
		System.out.println("imageUpdate: img="+img+" flags="+infoflags+" x="+x+" y="+y+" w="+width+" h="+height);
		if (0 != (infoflags & ALLBITS))
		{
			isDone = true;
			return true;
		}
		return false;
	}
}
