import gov.anl.gmca.common.*;
import gov.anl.gmca.io.*;
import gov.anl.gmca.io.PVLookup.*;
import gov.anl.gmca.sample.*;
import gov.anl.gmca.server.*;
import gov.anl.gmca.util.*;

import static gov.anl.gmca.server.DeviceInit.*;

public class TestMotor
{
    @org.junit.Test
    public void testMotor()
    {
        SimBeamline.start();
        Epics.connect();
        initMotors();
        for (int i=0;i<3;i++) {
            System.out.println("Waiting for devices to connect...");
            Util.sleep(1000);
        }
        System.out.println("Starting test");

        double actPos = Epics.getDouble(PV_PMAC.ActPos.motor("gonio_omega"));
        Util.printf("%s = %.2f", PV_PMAC.ActPos.motor("gonio_omega").toString(), actPos);
    }
}
