import gov.anl.gmca.common.ui.NBProgress;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;

public class TestPopup
{
    @org.junit.Test
    public void showProgress()
    {
        Shell shell = new Shell();
        NBProgress progress = new NBProgress(shell, SWT.APPLICATION_MODAL);
        progress.setText("Script message");
        progress.setMessage("Please wait for mono to stabilize...");
        progress.setWait_sec(5);
        progress.setRunnableOnSubmit(()->System.out.println("Sending response: "+progress.getReturnValue()));
        progress.asyncOpen();

        while (!shell.isDisposed()) {
            if (!shell.getDisplay().readAndDispatch()) {
                shell.getDisplay().sleep();
            }
        }
    }
}
