
# files generated or needed bxds in each step
XDS_INFO = {
    'jobs_all' : ('XYCORR', 'INIT', 'COLSPOT', 'IDXREF', 'DEFPIX', 'XPLAN', 'INTEGRATE', 'CORRECT'),
    'jobs_processing_all' : ('XYCORR', 'INIT', 'COLSPOT', 'IDXREF', 'DEFPIX', 'INTEGRATE', 'CORRECT'),
    'jobs_prep' : ('XYCORR', 'INIT', 'COLSPOT'),
    'jobs_index' : ('XYCORR', 'INIT', 'COLSPOT', 'IDXREF'),
    'jobs_integrate' : ('DEFPIX', 'INTEGRATE', 'CORRECT'),

    'files_generated_by_XYCORR' : ('XYCORR.LP', 'X-CORRECTIONS.cbf', 'Y-CORRECTIONS.cbf'),
    'files_generated_by_INIT' : ('INIT.LP', 'BKGINIT.cbf', 'BLANK.cbf', 'GAIN.cbf'),
    'files_generated_by_COLSPOT' : ('COLSPOT.LP', 'SPOT.XDS'),
    'files_generated_by_IDXREF' : ('IDXREF.LP', 'SPOT.XDS', 'XPARM.XDS'),
    'files_generated_by_DEFPIX' : ('DEFPIX.LP', 'ABS.cbf', 'BKGPIX.cbf'),
    'files_generated_by_INTEGRATE' : ('INTEGRATE.HKL', 'INTEGRATE.LP', 'FRAME.cbf'),
    'files_generated_by_CORRECT' : ('GXPARM.XDS', 'XDS_ASCII.HKL', 'CORRECT.LP',
                                    'GX-CORRECTIONS.cbf', 'GY-CORRECTIONS.cbf',
                                    'DX-CORRECTIONS.cbf', 'DY-CORRECTIONS.cbf',
                                    'MODPIX.cbf', 'DECAY.cbf', 'ABSORP.cbf'),
    'file_generated_by_XPLAN' : ('XPLAN.LP'),
    'files_generated_by_xdsstat' : ('XDSSTAT.LP', 'anom.pck', 'corr.pck', 'misfits.pck',
                                    'nobs.pck', 'peaks.pck', 'rf.pck',
                                    'rlps.pck', 'scales.pck'),

    'files_needed_by_XYCORR' : ('XDS.INP'),
    'files_needed_by_INIT' : ('XDS.INP', 'X-CORRECTIONS.cbf', 'Y-CORRECTIONS.cbf'),
    'files_needed_by_COLSPOT' : ('XDS.INP', 'BKGINIT.cbf', 'BLANK.cbf', 'GAIN.cbf',
                                 'X-CORRECTIONS.cbf', 'Y-CORRECTIONS.cbf'),
    'files_needed_by_IDXREF' : ('XDS.INP', 'SPOT.XDS'),
    'files_needed_by_XPLAN' : ('XDS.INP', 'XPARM.XDS', 'BKGPIX.cbf',
                               'X-CORRECTIONS.cbf', 'Y-CORRECTIONS.cbf'),
    'files_needed_by_DEFPIX' : ('XDS.INP', 'BKGPIX.cbf', 'XPARM.XDS',
                                'X-CORRECTIONS.cbf', 'Y-CORRECTIONS.cbf'),
    'files_needed_by_INTEGRATE' : ('XDS.INP', 'XPARM.XDS', 'BKGPIX.cbf', 'BLANK.cbf',
                                   'GAIN.cbf', 'X-CORRECTIONS.cbf', 'Y-CORRECTIONS.cbf'),
    'files_needed_by_CORRECT' : ('XDS.INP', 'INTEGRATE.HKL',
                                 'X-CORRECTIONS.cbf', 'Y-CORRECTIONS.cbf')
}